package IdPAccountManager::Data::AuthenticationToken;

use strict;
use warnings;

use base 'IdPAccountManager::DB::Object';

__PACKAGE__->meta->setup(
    table   => 'authenticationtokens',

    columns => [
        id            => { type => 'bigserial', not_null => 1 },
        token         => { type => 'varchar', length => 50, not_null => 1 },
        email_address => { type => 'varchar', length => 200, not_null => 1 },
        sp_entityid   => { type => 'varchar', length => 200, not_null => 1 },
        creation_date => { type => 'integer' },
    ],

    primary_key_columns => [ 'id' ],

    unique_keys => [
        [ 'token' ],
        [ 'email_address', 'sp_entityid' ],
    ],
);

1;

